package com.bjsxt.servlet;

import jdk.nashorn.internal.ir.CallNode;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.MultipartConfig;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Part;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.UUID;

@WebServlet(urlPatterns = {"/fileupload.do"})
@MultipartConfig
public class FileUploadServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //如果文件描述中可能有中文，先设置编码方式
        req.setCharacterEncoding("utf-8");
        String desc = req.getParameter("desc");//获取参数,文件描述
        Part part = req.getPart("file");//文件名
        //InputStream inputStream = desc.getInputStream();//获取文件上传的字节流
        //UUID.randomUUID.toString返回字符串+获取提交的文件名.substring截取（得到扩展名）=新的文件名（即改名）
        String FileName = UUID.randomUUID().toString()+part.getSubmittedFileName().substring(part.getSubmittedFileName().lastIndexOf("."));
        //相对路径转换为绝对路径（依赖servlet的context）
        ServletContext servletContext = this.getServletContext();
        String realPath = servletContext.getRealPath("images/" + FileName);//存放在web目录下的此位置
        part.write(realPath);//此对象可以把上传的文件做IO流处理，并通过输出流写到指定路径中
        //以下做个响应，证明上传是否成功
        resp.setContentType("text/html;charset=utf-8");
        PrintWriter out = resp.getWriter();
        //XML规范↓
        out.println("<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.0 Transitional//EN'>");
        out.println("<HTML>");
        out.println("<HEAD><TITLE> ITBZ </TITLE><HEAD>");
        out.println("<BODY>");
        out.println("上传成功"+"<br/>");//返回的类型如果有中文，还要做编码
        out.println("</BODY>");
        out.println("</HTML>");
        //XML规范↑
        out.flush();
        out.close();
    }
}
